=== debian/changelog ===
libpappsomspp (0.6.3-1) stretch; urgency=medium

  * better BaseTracePlotWidget
  * new callback function to cancel msrunreader operation
  * new set of objects to handle Bruker's Tims TOF raw data natively
  * new MsRunReaders for Bruker's Tims TOF raw data (incomplete)

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 11 Sep 2019 09:57:57 +0200

libpappsomspp (0.6.2-1) buster; urgency=medium

  * first buster package
  * new BaseTracePlotWidget designed by Filippo Rusconi
  * FastaFileIndexer object
  * new function hasScanNumbers to know if an MSrun file can be accessed using scan numbers
    (true with Thermo, false with others)
  * peptide palindrome test
  * new code to compute natural isotope average
  * new constructor Trace(const MapTrace &map_trace) to build directly a Trace from MapTrace

 -- Olivier Langella <olivier.langella@u-psud.fr>  Tue, 16 Jul 2019 14:23:52 +0200

libpappsomspp (0.6.1-1) stretch; urgency=medium

  * huge refactoring with Filippo Rusconi
  * work in progress to define a tree structure and browse MS runs
  * new object and API to align MS runs using the MS2 method

 -- Olivier Langella <olivier.langella@u-psud.fr>  Sat, 08 Jun 2019 19:29:09 +0200

libpappsomspp (0.6.0-1) stretch; urgency=medium

  * huge refactoring with Filippo Rusconi
  * all filters now available on a Trace object with a simple interface
  * peak detection as a new simple interface that can be used on any Trace
  * new feature to combine several traces or mass spectrum
  * mass spectrum scan numbers are deprecated in favor of a simple index of the scan
  * a new msfile accessor is available to handle multiple ms runs into a single file

 -- Olivier Langella <olivier.langella@u-psud.fr>  Thu, 23 May 2019 11:00:11 +0200

libpappsomspp (0.5.1-1) stretch; urgency=medium

  * better packaging
  * mutation support

 -- Olivier Langella <olivier.langella@u-psud.fr>  Sat, 23 Mar 2019 07:27:31 +0100

libpappsomspp (0.5.0-1) stretch; urgency=medium

  * library entirely refactored with Filippo Rusconi
  * better documentation
  * coding standards available

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 06 Feb 2019 10:27:13 +0100

libpappsomspp (0.4.5-1) stretch; urgency=medium

  * new package with graphical bug fix

 -- Olivier Langella <olivier.langella@u-psud.fr>  Tue, 08 Jan 2019 15:49:32 +0100

libpappsomspp (0.4.4-5) stretch; urgency=medium

  * new pwiz library

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 02 Jan 2019 21:24:24 +0100

libpappsomspp (0.4.4-3) stretch; urgency=medium

  * new qcustomplot library 2.0.1

 -- Olivier Langella <olivier.langella@u-psud.fr>  Tue, 11 Dec 2018 19:07:06 +0100

libpappsomspp (0.4.4-1) unstable; urgency=low

  * Packaging for first upload to the NEW queue.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 11 Dec 2018 11:06:34 +0100

libpappsomspp (0.4.3-2) stretch; urgency=medium

  * fix MGF precursor scan num empty

 -- Olivier Langella <olivier.langella@u-psud.fr>  Fri, 02 Nov 2018 13:44:50 +0100
