=== debian/control ===
Source: libpappsomspp
Maintainer: Olivier Langella <olivier.langella@u-psud.fr>
Homepage: http://pappso.inra.fr/bioinfo
Section: libs
Priority: optional
Build-Depends: debhelper (>= 10),
               cmake (>= 2.6),
               d-shlibs,
               qtbase5-dev,
               libqt5svg5-dev (>= 5.7.0),
               libqcustomplot-dev(>= 2.0.1),
               libpwiz-dev,
               libboost-dev,
               libodsstream-qt5-dev,
               libalglib-dev,
               libsqlite3-dev,
               libzstd-dev (>= 1.3.8),
               doxygen
Standards-Version: 4.3.0
Vcs-Browser: https://sourcesup.renater.fr/scm/browser.php?group_id=1721
Vcs-Git: git://git.renater.fr/pappsomspp.git


Package: libpappsomspp-qt5-0
Depends: libpappsomspp0, ${misc:Depends}
Architecture: all
Priority: optional
Section: oldlibs
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: libpappsomspp0
Section: libs
Architecture: any
Multi-Arch: same
Replaces: libpappsomspp-qt5-0 (<< 0.6.0)
Breaks: libpappsomspp-qt5-0 (<< 0.6.0)
Depends: ${shlibs:Depends},
         ${misc:Depends},
Description: C++ library to handle proteomic data (non-gui runtime files)
 libpappsomspp provides a simple API to handle peptides, spectrum,
 ions, amino acid mofifications...
 .
 This package ships the non-GUI library.


Package: libpappsomspp-qt5-dev
Depends: libpappsomspp-dev, ${misc:Depends}
Architecture: all
Priority: optional
Section: oldlibs
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: libpappsomspp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Replaces: libpappsomspp-qt5-dev (<< 0.6.0)
Breaks: libpappsomspp-qt5-dev (<< 0.6.0)
Depends: libpappsomspp0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends},
Description: C++ library to handle proteomic data (development files)
 libpappsomspp provides a simple API to handle peptides, spectrum,
 ions, amino acid mofifications...
 .
 This package ships the development files.


Package: libpappsomspp-widget-qt5-0
Depends: libpappsomspp-widget0, ${misc:Depends}
Architecture: all
Priority: optional
Section: oldlibs
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: libpappsomspp-widget0
Section: libs
Architecture: any
Multi-Arch: same
Replaces: libpappsomspp-widget-qt5-0 (<< 0.6.0)
Breaks: libpappsomspp-widget-qt5-0 (<< 0.6.0)
Depends: libpappsomspp0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends},
Description: C++ library to handle proteomic data (gui runtime files)
 libpappsomspp provides a simple API to handle peptides, spectrum,
 ions, amino acid mofifications...
 .
 This package ships the GUI library.


Package: libpappsomspp-widget-qt5-dev
Depends: libpappsomspp-widget-dev, ${misc:Depends}
Architecture: all
Priority: optional
Section: oldlibs
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: libpappsomspp-widget-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Replaces: libpappsomspp-widget-qt5-dev (<< 0.6.0)
Breaks: libpappsomspp-widget-qt5-dev (<< 0.6.0)
Depends: ${shlibs:Depends},
         ${misc:Depends},
Description: C++ library to handle proteomic data (gui development files)
 libpappsomspp provides a simple API to handle peptides, spectrum,
 ions, amino acid mofifications...
 .
 This package ships the development files.

Package: libpappsomspp-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: C++ library to handle proteomic data (developer documentation)
 libpappsomspp provides a simple API to handle peptides, spectrum,
 ions, amino acid mofifications.
 .
 This packages ships the Doxygen-based developer documentation.
