=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --buildsystem=cmake
#	dh $@ --buildsystem=cmake --parallel

override_dh_auto_configure:
	dh_auto_configure -- -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" -DCMAKE_INSTALL_PREFIX=/usr -DUSEQT4=0 -DUSEQT5=1 -DCMAKE_BUILD_TYPE=Release  -DMAKE_TEST=0 -DCMAKE_SKIP_RPATH=1 -DUSEPAPPSOTREE=0

override_dh_auto_build:
	dh_auto_build --no-parallel
	dh_auto_build -- doc
